 function [q,F,INFO] = snoptmain0()
%function [q,F,INFO] = snoptmain()
% Defines the NLP problem and calls the simplest
% version of the mex interface for snopt.

% q(1) = q1h
% q(2) = q2h
% q(3) = q3h

%snseti ('Major Iteration limit', 250);% ? Don't know what it makes ?? 
%snoptmainPLN4.spc = which('snoptmainPLN4.spc');
%snspec ( snoptmainPLN4.spc );

snoptmain.spc = which('snoptmain.spc');
snspec ( snoptmain.spc );



%snprint('sntoy4.out');
%snsummary('snsum4.out');
%snscreen on;

% Let everyone know all is well!


%display('Reached Here')

%display('Reached Here')



[q,qlow,qupp,xmul,xstate,Flow,Fupp,Fmul,Fstate,ObjAdd,ObjRow, ...
    AA,iAfun,jAvar,iGfun,jGvar] = ProblemData;

snset  ('Minimize');

[q,F,xmul,Fmul,INFO] = snsolve(q,qlow,qupp,xmul,xstate, ...
                               Flow,Fupp,Fmul, Fstate, ...
                               ObjAdd, ObjRow, AA, iAfun, jAvar, ...
                               iGfun, jGvar, 'snoptuserfun0');

% itns   =  sngeti ('iw 421')
% majors =  sngeti ('iw 422')

snprint off; % Closes the file and empties the print buffer


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [q,qlow,qupp,xmul,xstate, Flow,Fupp,Fmul,Fstate,ObjAdd,ObjRow, ...
          AA,iAfun,jAvar,iGfun,jGvar] = ProblemData()
     
     
global ndir is in q_opt_iter
global yy zz

state(1)     = yy;
state(2)     = zz;


istart       = 1;

ObjRow       = 1;
ObjAdd       = 0;
     
ns           = 3; % no of shocks
ni           = 2; % no of agents

   

nCon         =  ni;
nVar         =  ni*(ns+1);
neF          =  nCon + 1;


xmul         = zeros(nVar,1);
xstate       = zeros(nVar,1);
Fmul         = zeros(neF,1);
Fstate       = zeros(neF,1);

AA           = [];
iAfun        = [];
jAvar        = [];

Obj          =   1;


% The Objective row is always free.

Flow(Obj)  = -Inf;
Fupp(Obj)  =  Inf;

% Constraints

for i=1:ni
    Flow(i+1) = 0;
    Fupp(i+1) = 0;
end

Flow = Flow';
Fupp = Fupp'; 

% Ranges for q.

qlow =  zeros(nVar,1);
qupp =  100*ones(nVar,1);



% Start values

for i=1:ni
 q(i) =q_opt_iter(is,in,1);
end

for i=1:ni
    for j=1:ns
        q(ni+(i-1)*ns+j) = state(i)+q(i);
    end
end

q =q';


% The G matrix records the locations of nonzeros in the Jacobian.


G = [1,  1 ;
     1,  2 ;
     1,  3 ;
     1,  4 ;
     1,  5 ;
     1,  6 ;
     1,  7 ;
     1,  8 ;
     2,  1 ;
     2,  3 ;
     2,  4 ;
     2,  5 ;
     3,  2 ;
     3,  6 ;
     3,  7 ;
     3,  8 ];
 
iGfun = G(:,1);
jGvar = G(:,2);

%q   =  ones(n,1);

